Bug 1547955 - Undercloud / Overcloud Heat stack fails on: YAQL list index out of range (includes upgrades cases)
Summary: Undercloud / Overcloud Heat stack fails on: YAQL list index out of range (inc...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat OpenStack
Classification: Red Hat
Component: openstack-tripleo-heat-templates
Version: 12.0 (Pike)
Hardware: All
OS: Unspecified
high
medium
Target Milestone: z2
: 12.0 (Pike)
Assignee: Emilien Macchi
QA Contact: Gurenko Alex
URL:
Whiteboard:
Depends On: 1547949
Blocks: 1547956 1547957
TreeView+ depends on / blocked
 
Reported: 2018-02-22 11:20 UTC by Sergii Golovatiuk
Modified: 2018-03-28 17:18 UTC (History)
10 users (show)

Fixed In Version: openstack-tripleo-heat-templates-7.0.9-2.el7ost
Doc Type: If docs needed, set a value
Doc Text:
Clone Of: 1547949
: 1547956 (view as bug list)
Environment:
Last Closed: 2018-03-28 17:17:34 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2018:0602 None None None 2018-03-28 17:18:18 UTC

Description Sergii Golovatiuk 2018-02-22 11:20:42 UTC
+++ This bug was initially created as a clone of Bug #1547949 +++

The latest YAQL (1.1.3-2.el7) introduces backward incompatible change which was not present in YAQL (1.1.0-3.el7) and below. In order to be able to upgrade to latest YAQL and not to break any new deployments or upgrades YAQL expression should be rewritten to version which is compatible in all YAQL versions. 

Upstream bug: https://bugs.launchpad.net/tripleo/+bug/1750032
Upstream fix: https://review.openstack.org/#/c/545856/1

Comment 12 Sergii Golovatiuk 2018-03-13 15:41:01 UTC
puddle will have yaql-1.1.0 that's correct. The problem is that RHOSP 13 comes with yaql 1.1.3 which acts differently. During undercloud upgrade yaql will be upgraded from 1.1.0 to 1.1.3. In this case, yaql expression will fail to equate. So, this patch refactor yaql equation to format which works exactly in yaql 1.1.0 and 1.1.3. In this case upgrade won't fail as expression will be evaluated identically in 1.1.0 and 1.1.3.

Comment 13 Gurenko Alex 2018-03-13 16:43:18 UTC
In this case puddle 2018-03-10.1 comes with patches with following package:

[stack@undercloud-0 ~]$ rpm -q openstack-tripleo-heat-templates
openstack-tripleo-heat-templates-7.0.9-6.el7ost.noarch

[stack@undercloud-0 ~]$ sed -n '516p' /usr/share/openstack-tripleo-heat-templates/overcloud.j2.yaml
          expression: dict($.data.where($ != null).flatten().selectMany($.items()).groupBy($[0], $[1]).select([$[0], $[1].flatten()]))

other changes from the commit are also there, so we're good to go.

Comment 16 errata-xmlrpc 2018-03-28 17:17:34 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHSA-2018:0602


Note You need to log in before you can comment on or make changes to this bug.